<template>
    <v-card class="pa-3 mt-3" :style="{ backgroundColor: receiptColor(receiptState.selectedExpenditureType) }">
        <v-card-title>{{ $t("receipt.newReceipt") }}</v-card-title>
        <v-card-text>
            <v-col cols="12" align="center" justify="center">
                <v-file-input
                    filled
                    accept="image/png, image/jpeg, image/bmp"
                    prepend-icon="mdi-camera"
                    :placeholder="$t('receipt.takePicture')"
                    capture="environment"
                    outlined
                    dense
                    @change="changeImage"
                ></v-file-input>
                <v-file-input
                    filled
                    accept="image/png, image/jpeg, image/bmp"
                    prepend-icon="mdi-camera"
                    :placeholder="$t('receipt.uploadLocalPicture')"
                    type="file"
                    outlined
                    dense
                    @change="changeImage"
                ></v-file-input>
                <v-img v-if="receiptState.image" max-height="250" max-width="250" :src="receiptState.image" @click="$emit('showFullScreen', receiptState.image)" />
            </v-col>
            <v-row class="pt-4 pb-4" justify="space-around" align="center">
                <v-col cols="5">
                    <v-select v-model="receiptState.selectedExpenditureType" :items="expenditureTypesSelectTranslated" :label="$t('receipt.expenditureType')" dense outlined></v-select>
                </v-col>
                <v-col cols="5">
                    <v-text-field
                    v-model="receiptState.amount"
                    :label="$t('receipt.amount')"
                    prefix="JPY"
                    dense
                    ></v-text-field>
                </v-col>
            </v-row>

        </v-card-text>
        <v-card-actions>
            <v-col cols="12"  align="center" justify="center">
                <v-btn color="primary" :loading="loading" fab @click="save"><font-awesome-icon icon="save" size="2x" /></v-btn>
            </v-col>
        </v-card-actions>
    </v-card>
</template>

<script lang="ts">
import { Component, Inject, Prop, Vue } from 'vue-property-decorator'
import { expenditureTypes, expenditureTypesSelectTranslated, expenditureColors } from "@/utils/categories"
import { Observer } from "mobx-vue";
import { ReceiptModel } from "@/store/modules/receipt";
import { RootStore } from "@/store"

@Observer
@Component({})
export default class Day extends Vue {
    public expenditureTypes: Array<string> = expenditureTypes
    public expenditureTypesSelectTranslated: Record<string, string>[] = expenditureTypesSelectTranslated
    public imageSource: string = ""
    public image: string = ""
    @Prop({ default: "2021-08-01", type: String }) public day!: string
    private dialog: boolean = false
    private expenditureColors: string[] = expenditureColors
    private fullScreenImage: string = ""
    @Inject("root") root !: RootStore
    private receiptState = new ReceiptModel(this.root);
    private loading: boolean = false;

    private receiptColor(expenditureType: string) {
        const idx = expenditureTypes.indexOf(expenditureType);
        return this.expenditureColors[idx];
    }

    private changeImage(userImage: File): void {
        if (userImage === null) {
            this.receiptState.removeImage();
            return;
        } else {
            this.addImage(userImage);
        }
    }

    private addImage(userImage: File): void {
        let reader = new FileReader();
        reader.onload = () => {
            if (reader.result) this.receiptState.setImage(reader.result as string);
        }
        reader.readAsDataURL(userImage);
    }

    private isUserDataCorrect() {
        return this.receiptState.amount !== "" && this.receiptState.selectedExpenditureType !== "" && this.receiptState.image !== "";
    }

    private async save() {
        if (!this.isUserDataCorrect()) {
            this.$notify(this.$t("common.dataIncorrect"));
            return;
        }
        this.loading = true;
        const [year, month, day ] = this.day.split("-");
        const receiptDate = new Date(Number(year), Number(month) - 1, Number(day), 15, 0, 0).getTime();
        const receipt = await this.receiptState.saveReceipt(receiptDate);
        this.$emit('onDone', receipt);
        this.loading = false;
    }
}
</script>
